function ICoor.LoadQueue()
	local stgs = ICoor.Globals.Queue;

	ICoor.Queue:SetPoint(stgs.AnchorPoint, stgs.RelativeTo, stgs.RelativePoint, stgs.Location[1], stgs.Location[2]);
	ICoor.Queue:SetSize(stgs.Size[1], stgs.Size[2]);

	ICoor.Queue.texture = ICoor.Queue:CreateTexture(nil, "LOW");
	ICoor.Queue.texture:SetTexture(ICoor.Globals.Textures.Flat);
	local c = stgs.Color;
	ICoor.Queue.texture:SetVertexColor(c[1], c[2], c[3], c[4]);
	ICoor.Queue.texture:SetAllPoints(ICoor.Queue);

	ICoor.Queue.Text = {};
	for i = 1, 5 do
		ICoor.Queue.Text[i] = ICoor.Queue:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		ICoor.Queue.Text[i]:SetFont(ICoor.Globals.Textures.Text, stgs.FontSize);
		local c = stgs.FontColor;
		ICoor.Queue.Text[i]:SetTextColor(c[1], c[2], c[3], c[4]);

		local h = stgs.Size[2] / 5;
		ICoor.Queue.Text[i]:SetPoint("TOP", "ICoor_Queue", "TOP", 0, -h * (i - 1));
		ICoor.Queue.Text[i]:SetSize(stgs.Size[1], h);
		ICoor.Queue.Text[i]:SetJustifyH("CENTER");
		ICoor.Queue.Text[i]:SetWordWrap(true);
		ICoor.Queue.Text[i]:SetText(ICoor.Table[i]);
	end
end

function ICoor.Queue:Draw()
	for i = 1, 5 do
		self.Text[i]:SetText(ICoor.Table[i]);
	end
end

function ICoor.Queue:Jump(name, position)
	for i = 5, position + 1, -1 do 
		ICoor.Table[i] = ICoor.Table[i - 1];
	end
	ICoor.Table[position] = name;
	self:Draw();
end

function ICoor.Queue:Leave(name)
	local found = false;
	for i = 1, 5 do
		if ICoor.Table[i] == name then
			found = true;
		end
		if found then
			if ICoor.Table[i + 1] == nil then
				ICoor.Table[i] = "None";
			else
				ICoor.Table[i] = ICoor.Table[i + 1];
			end
		end
	end
	self:Draw();
end

function ICoor.Queue:Join(name)
	for i = 1, 5 do
		if ICoor.Table[i] == "None" then
			ICoor.Table[i] = name;
			self:Draw();
			return;
		end
	end
end

function ICoor.Queue:Load(name1, name2, name3, name4, name5)
	ICoor.Table = {name1, name2, name3, name4, name5};
	for i = 1, 5 do
		self.Text[i]:SetText(ICoor.Table[i]);
	end
end