local vCheck = CreateFrame("Frame");
local vCheckData = {};
local currentVersion = GetAddOnMetadata("InterruptCoordinator", "Version");
local timeSinceCheck = 0;

local function VersionChecker()
	local latestVersion = 0;
	local latestVersionString = "";
	local latestNames = {};
	local notLatest = {};
	local notInstalled = {};

	for i = 1, table.getn(vCheckData) do
		if tonumber(vCheckData[i].ver) > latestVersion then
			latestVersion = tonumber(vCheckData[i].ver);
			latestVersionString = vCheckData[i].ver;
		end
	end

	for i = 1, table.getn(vCheckData) do
		if tonumber(vCheckData[i].ver) == latestVersion then
			table.insert(latestNames, vCheckData[i].name);
		else
			table.insert(notLatest, vCheckData[i]);
		end
	end

	for i = 1, GetNumGroupMembers() do
		local name = GetUnitName("raid" ..i, false);
		local inlist = false;
		for x = 1, table.getn(vCheckData) do
			if vCheckData[x].name == name then
				inlist = true;
			end
		end
		if inlist ~= true then
			table.insert(notInstalled, name);
		end
	end

	local latestNamesString = "[Interrupt Coordinator] Latest Version (" ..latestVersionString.. "): ";
	for i = 1, table.getn(latestNames) do
		latestNamesString = latestNamesString ..latestNames[i] .." ";
	end
	DEFAULT_CHAT_FRAME:AddMessage(latestNamesString, 0, 1, 0);

	local outofDateString = "[Interrupt Coordinator] Out of date: ";
	for i = 1, table.getn(notLatest) do
		outofDateString = outofDateString ..notLatest[i].name .." (" ..notLatest[i].ver ..") ";
	end
	DEFAULT_CHAT_FRAME:AddMessage(outofDateString, 1, 1, 0);

	local notInstalledString = "[Interrupt Coordinator] Not installed: "
	for i = 1, table.getn(notInstalled) do
		notInstalledString = notInstalledString ..notInstalled[i] .." ";
	end
	DEFAULT_CHAT_FRAME:AddMessage(notInstalledString, 1, 0, 0);
end

local function TimerUpdate(self, elapsed)
	timeSinceCheck = timeSinceCheck + elapsed;
	if timeSinceCheck < 2 then return end
	timeSinceCheck = 0;
	VersionChecker();
	self:SetScript("OnUpdate", nil);
end

SLASH_INTERRUPTCOORDINATOR1 = '/icoor';
local function ChatCommand(msg, editbox)
	vCheckData = {};
	SendChatMessage("[Interrupt Coordinator] Sending a version check!", "RAID", "Common");
	SendAddonMessage("ICoor", "check", ICoorSendType);
	vCheck:SetScript("OnUpdate", TimerUpdate);
end
SlashCmdList["INTERRUPTCOORDINATOR"] = ChatCommand;

local function OnEvent(self, event, prefix, message, channel, sender)
	if event == "CHAT_MSG_ADDON" then
		if prefix ~= "ICoor" then return end
		words = {}
		for word in message:gmatch("([^_]+)") do table.insert(words, word) end
		if words[1] == "check" then
			SendAddonMessage("ICoor", "ver_" ..currentVersion, "RAID");
		elseif words[1] == "ver" then
			senderShorts = {}
			for senderShort in sender:gmatch("([^-]+)") do table.insert(senderShorts, senderShort) end
			local dataInsert = {
				name = senderShorts[1],
				ver = words[2],
			};
			table.insert(vCheckData, dataInsert);
		end
	end
end

vCheck:RegisterEvent("CHAT_MSG_ADDON");
vCheck:SetScript("OnEvent", OnEvent);